// ----------------------------------------------------------------------------
// ADC_1.h 
// ----------------------------------------------------------------------------
// Beschreibung:	ADC_1 MPC5646C Defines und Prototypen
//		
// Revision:		06. Januar 2017, neu	Reiling, IPE
//					
// ----------------------------------------------------------------------------

#ifndef _ADC_1_H_
#define _ADC_1_H_


//====================================================================
// defines

#define U12under	11400		// 12V - 5%
#define U12over   	12600		// 12V + 5%
#define U33under	3135		// 3,3V - 5%
#define U33over		3465		// 3,3V + 5%

#define NoError      0
#define ADCtimeout  -1
#define ADCwrongCH  -2
#define Under12V    -3
#define Over12V     -4
#define Under3_3V   -5
#define Over3_3V    -6


//====================================================================
// API

extern int8_t ADC_1_init(void);
//init des der ADC_1 Eingnge und des ADC_1 Modes

extern int8_t ADC_1_run(uint8_t Channel, uint16_t* Result);
//ADC_1[Channel] wird mit 64-fach OverSampling gemessen
//Ergebnis hat 16 Bit
//Channel: ADC1=0 bis ADC12=11

extern int8_t CheckSupplyVoltages(uint16_t* U12, uint16_t* U33);
//12V und 3,3V Betriebsspannung gemessen und auf ber- bzw Unterspannung getestet


#endif  /* ifndef*/
