//==============================================================================
// Purpose:     DigitalOutput-Ansteuerung
//
// Created on:  21.09.2012 by IPE
//
// History
//		21.09.2012 neu, T.Maurer
//==============================================================================

#ifndef __RelaisLEDs_H__
#define __RelaisLEDs_H__



#ifdef __cplusplus
    extern "C" {
#endif

//==============================================================================
// Include files


//Master-Board LED-Pins
//MPC-RM S.75ff
#define PIN_REGNR_LED1		158	//Port PJ[14] = PCR[158]
#define PIN_REGNR_LED2		159	//PJ[15] = PCR[159]
#define PIN_REGNR_LED3		160	//PK[0] = PCR[160] // high == Power Relais disconnected low = Power-Relais Connected
#define PIN_REGNR_LED4		4	//PA[4] = PCR[4]	// high = no Error Low = Error

//Master-Board HighSide-Switches Out-Pins
#define PIN_REGNR_HS1	80	//PF[0]
#define PIN_REGNR_HS2	81	//PF[1]
#define PIN_REGNR_HS3	82	//PF[2]
#define PIN_REGNR_HS4	83	//PF[3]
#define PIN_REGNR_HS5	84	//PF[4]
#define PIN_REGNR_HS6	85	//PF[5]
#define PIN_REGNR_HS7	86	//PF[6]
#define PIN_REGNR_HS8	87	//PF[7]
//Master-Board Relais-Switches Out-Pins
#define PIN_REGNR_RELAIS_PLUS	144	//PJ[0]
#define PIN_REGNR_RELAIS_PRECHA 145	//PJ[1]
#define PIN_REGNR_RELAIS_SLAVE	146	//PJ[2]
#define PIN_REGNR_PWR_SUPPLY	107 //PG[11]        


//ISO Inputs
#define PIN_REGNR_MHS		22		// PB[6] (ADC3) = PCR[108]
#define PIN_REGNR_OKHS		23		// PB[7] (ADC4) = PCR[109]    
    
//API
extern void RelaisLEDs_init();
extern uint8_t RelaisLEDs_TM_update(uint8_t tick);	//TestMode

#ifdef __cplusplus
    }
#endif


#endif  /* ifndef*/
